diff -urN origsrc/tscreen-0.4.9/utmp.c src/tscreen-0.4.9/utmp.c
--- origsrc/tscreen-0.4.9/utmp.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/utmp.c	2011-06-21 17:42:04.718750000 +0900
@@ -89,7 +89,7 @@
 static int  initutmp __P((void));
 static void setutent __P((void));
 #endif
-#if defined(linux) && defined(GETUTENT)
+#if (defined(linux) || defined (__CYGWIN__)) && defined(GETUTENT)
 static struct utmp *xpututline __P((struct utmp *utmp));
 # define pututline xpututline
 #endif
@@ -581,11 +581,7 @@
     }
 #endif
   setutent();
-#ifndef __CYGWIN__
   return pututline(u) != 0;
-#else
-  return 1;
-#endif
 }
 
 static void
@@ -593,7 +589,7 @@
 struct utmp *u;
 {
   u->ut_type = DEAD_PROCESS;
-#if (!defined(linux) || defined(EMPTY)) && !defined(__CYGWIN__)
+#if (!defined(linux) && !defined (__CYGWIN__)) || defined(EMPTY)
   u->ut_exit.e_termination = 0;
   u->ut_exit.e_exit = 0;
 #endif
@@ -612,7 +608,7 @@
   u->ut_type = USER_PROCESS;
   strncpy(u->ut_user, user, sizeof(u->ut_user));
   /* Now the tricky part... guess ut_id */
-#if defined(sgi) || defined(linux)
+#if defined(sgi) || defined(linux) || defined (__CYGWIN__)
   strncpy(u->ut_id, line + 3, sizeof(u->ut_id));
 #else /* sgi */
 # ifdef _IBMR2
@@ -868,7 +864,7 @@
 }
 # endif /* BUGGYGETLOGIN */
 
-#if defined(linux) && defined(GETUTENT)
+#if (defined(linux) || defined (__CYGWIN__)) && defined(GETUTENT)
 # undef pututline
 
 /* aargh, linux' pututline returns void! */
diff -urN origsrc/tscreen-0.4.9/window.c src/tscreen-0.4.9/window.c
--- origsrc/tscreen-0.4.9/window.c	2008-10-24 23:22:38.000000000 +0900
+++ src/tscreen-0.4.9/window.c	2011-06-21 17:41:49.328125000 +0900
@@ -989,6 +989,9 @@
   RemoveUtmp(wp);
 #endif
   CloseDevice(wp);
+  /* signal the child process to exit */
+  /* FIXME: is this right if wp->w_pwin? */
+  Kill(wp->w_pid, SIGHUP);
 
   if (wp == console_window)
     {
@@ -1467,6 +1470,8 @@
   return pid;
 }
 
+#ifndef __CYGWIN__
+
 void
 execvpe(prog, args, env)
 char *prog, **args, **env;
@@ -1513,6 +1518,8 @@
     errno = EACCES;
 }
 
+#endif /* __CYGWIN__ */
+
 #ifdef PSEUDOS
 
 int
